//-----------------------------------------------------------------------------
//
// Title       : MIPS R2001 for CSE 370 (Winter 2005)
// Design      : mips2001
// Author      : Gaetano Borriello
// Company     : UW/CSE
//
//-----------------------------------------------------------------------------
//
// File        : z:\testdir\mips2001\mips2001\compile\mips2000.v
// Generated   : Tue May 15 19:03:57 2007
// From        : z:\testdir\mips2001\mips2001\src\mips2000.bde
// By          : Bde2Verilog ver. 2.01
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`ifdef _VCP
`else
`define library
`endif


// ---------- Design Unit Header ---------- //
`timescale 1ps / 1ps

module mips2000 (clk,reset) ;

// ------------ Port declarations --------- //
input clk;
wire clk;
input reset;
wire reset;

// ----------- Signal declarations -------- //
wire neg;
wire NET34560;
wire NET36923;
wire NET37426;
wire NET37519;
wire NET37531;
wire srcB;
wire zero;
wire [31:0] BUS28374;
wire [31:0] BUS33595;
wire [31:0] BUS34201;
wire [31:0] BUS34427;
wire [31:0] BUS36799;
wire [1:0] BUS36978;
wire [1:0] BUS37010;
wire [5:0] BUS37111;
wire [31:0] Inst;
wire [31:0] Next;
wire [31:0] PC;
wire [1:0] PCSel;
wire [31:0] RegA;
wire [31:0] RegB;

// -------- Component instantiations -------//

Controller U1
(
	.ALUctrl(BUS37111),
	.Inst(Inst),
	.MemRead(NET37519),
	.MemWrite(NET37531),
	.PCSel(PCSel),
	.neg(neg),
	.regWrite(NET36923),
	.reset(NET37426),
	.srcB(srcB),
	.wrDataSel(BUS37010),
	.wrRegSel(BUS36978),
	.zero(zero)
);



InstMemory U10
(
	.Inst(Inst),
	.address(PC)
);



wrDataMux U11
(
	.ALU(BUS36799),
	.Mem(BUS34427),
	.Next(Next),
	.Out(BUS34201),
	.wrDataSel(BUS37010)
);



assign NET37426 = reset;


assign NET34560 = NET37531 & clk;


PCupdate U3
(
	.Inst(Inst[25:0]),
	.Next(Next),
	.PC(BUS28374),
	.PCSel(PCSel),
	.Reg(RegA)
);



ALU U4
(
	.A(RegA),
	.ALUop(BUS37111),
	.Imm(BUS33595),
	.Out(BUS36799),
	.RegB(RegB),
	.neg(neg),
	.srcB(srcB),
	.zero(zero)
);



PC U5
(
	.PC(PC),
	.clk(clk),
	.next_PC(BUS28374),
	.reset(reset)
);



RegFile U6
(
	.Inst(Inst),
	.RegA(RegA),
	.RegB(RegB),
	.WriteData(BUS34201),
	.clk(clk),
	.regWrite(NET36923),
	.wrRegSel(BUS36978)
);



increment U7
(
	.Next(Next),
	.PC(PC)
);



signEx U8
(
	.in(Inst[31:0]),
	.out(BUS33595)
);



DataMemory U9
(
	.address(BUS36799),
	.read(NET37519),
	.readData(BUS34427),
	.write(NET34560),
	.writeData(RegB)
);



endmodule 
