//--------------------------------------------------------------------------------------------------
//
// Title       : increment
// Design      : mips2000
//
//-------------------------------------------------------------------------------------------------
//
// Description :	Increment program counter by one to point on next address
//
//-------------------------------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module increment (
	input	[31:0]	PC,
	output	[31:0]	Next
);

assign Next = PC+1;

endmodule
